SystemOrganization addCategory: #Nautilus!

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 11:27'!
<= aRPackage 

	^ self name <= aRPackage name! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/25/2011 14:51'!
fileOut

	self error: 'I should be implemented somehow'! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 12:40'!
orderedClasses

	| tmp |
	tmp := self definedClasses asArray sort: [:a :b | a name <= b name].
	tmp := tmp, (self extendedClasses asArray sort: [:a :b | a name <= b name]).
	^tmp
! !

!RecentMessageList methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/26/2011 00:10'!
lastClasses: anInteger

	"I return the last anInteger classes modified"
	| result tempList |
	result := OrderedCollection new.
	tempList := self methodReferenceList copy sort: [:a :b | a timeStamp >= b timeStamp].
	
	tempList do: [:method || class |
		result size = anInteger ifTrue: [^result].
		class := method actualClass.
		(result includes: class) ifFalse: [result add: class]].
	^ result! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/26/2011 00:45'!
containsHalt

	^ self literals includes: #halt.! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/26/2011 00:29'!
isOverride
	
	| selectors |
	selectors := self methodClass allSuperclasses gather: [:each | each selectors ].
	^ selectors includes: self selector! !

!CompiledMethod methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/26/2011 00:32'!
isOverriden
	
	| selectors |
	selectors := self methodClass allSubclasses gather: [:each | each selectors ].
	^ selectors includes: self selector! !

StandardWindow subclass: #NautilusWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusWindow commentStamp: '<historical>' prior: 0!
I am a subclass of StandardWindow with my own icon

Maybe I'm useless, but right now I'm not on the top of the to do list!

!NautilusWindow methodsFor: 'thumbnail' stamp: 'BenjaminVanRyseghem 3/18/2011 10:30'!
icon

	^ NautilusUI icon! !

!NautilusWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 3/20/2011 06:15'!
initialExtent

	^ 700@500! !

!Trait methodsFor: '*Nautilus' stamp: 'BenjaminVanRysghem 3/17/2011 16:32'!
superclass
	" use to be polymorphic with classes "

	^ nil! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 17:16'!
createPackageNamed: aString

	| instance |
	(packages includesKey: (Symbol readFromString: '#', aString))
		ifTrue: [ ^ self openAreadyExistingError ].
	
	instance := RPackage named: aString.
	self registerPackage: instance.
	^ instance! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 16:51'!
openAreadyExistingError

	StandardWindow new alert: 'A package with this name already exists' title: 'Already exists'! !

!RPackageOrganizer methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 18:04'!
renamePackage: aPackage in: aString

	self haltIf: [aPackage isNil].
	(packages includesKey: (Symbol readFromString: '#', aString))
		ifTrue: [ ^ self openAreadyExistingError ].
	self unregisterPackage: aPackage.
	aPackage name: aString.
	self registerPackage: aPackage.
	^ aPackage! !

!BrowserEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/27/2011 15:45'!
packageOrganizer

	^ RPackageOrganizer default! !

!BrowserEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 18:16'!
packages

	^ self packageOrganizer packages! !

!ClassEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/25/2011 17:02'!
packages

	^ (self classes gather: [:each | each packages]) asSet! !

Object subclass: #Nautilus
	instanceVariableNames: 'browsedEnvironment ui selectedPackage selectedCategory selectedMethod selectedClass selectedGroup showPackages showGroups showHierarchy showComment showInstance showCategories'
	classVariableNames: 'Groups OpenOnGroups RecentClasses ShowHierarchy'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses'!

!Nautilus commentStamp: 'BenjaminVanRyseghem 3/17/2011 16:20' prior: 0!
Nautilus new open !

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses'!

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/22/2011 11:37'!
browsedEnvironment: anEnvironment

	^ self new browsedEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:41'!
buildGroupManager

	| holder |
	holder := GroupsHolder new.
	(holder 
		addADynamicGroupSilentlyNamed: 'Most Viewed Classes' 
		model: self 
		selector: #recentClassesElements) removable: false.
	(holder
		addADynamicGroupSilentlyNamed: 'Last Modified Classes' 
		model: self 
		selector: #lastModifiedClasses) removable: false.
	^ holder
			! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/24/2011 14:40'!
classEvent: anEvent

	self allInstances do: [:each | each classChanged: anEvent item ].
	anEvent isAdded
		ifTrue: [ self resetCachedLastClasses].
	anEvent isCommented
		ifTrue: [ self resetCachedLastClasses].
	anEvent isModified
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRecategorized
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRenamed
		ifTrue: [ self resetCachedLastClasses].
	anEvent isReorganized
		ifTrue: [ self resetCachedLastClasses].! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 13:27'!
defaultBrowsedEnvironment

	^ BrowserEnvironment new! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/18/2011 16:44'!
event: anEvent
	"Hook for SystemChangeNotifier"

	anEvent itemKind = SystemChangeNotifier classKind
		ifTrue:[ self classEvent: anEvent].
	anEvent itemKind = SystemChangeNotifier methodKind
		ifTrue:[ self methodEvent: anEvent].	
	! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:15'!
groupsManager

	^ Groups ifNil: [ Groups := self buildGroupManager]! !

!Nautilus class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/20/2011 01:27'!
icon 

	^ NautilusUI icon! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/18/2011 16:42'!
initialize

	super initialize.
	self startUp! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:26'!
lastModifiedClasses

	^ cachedLastClasses ifNil: [ cachedLastClasses := RecentMessageList uniqueInstance lastClasses: 10 ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:45'!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:48'!
methodEvent: anEvent

	self allInstances do: [:each | each methodChanged: anEvent item].
	anEvent isAdded
		ifTrue: [ self resetCachedLastClasses].
	anEvent isCommented
		ifTrue: [ self resetCachedLastClasses].
	anEvent isModified
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRecategorized
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRenamed
		ifTrue: [ self resetCachedLastClasses].
	anEvent isReorganized
		ifTrue: [ self resetCachedLastClasses].! !

!Nautilus class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/23/2011 13:06'!
nautilusMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #Nautilus)
		action: [self open];
		order: 0;
		help: 'Ready to browse the deeps of the system ?';
		icon: self icon! !

!Nautilus class methodsFor: 'settings' stamp: 'BenjaminVanRyseghem 3/22/2011 14:09'!
nautilusSettingsOn: aBuilder
	<systemsettings>
	
	(aBuilder group: #Nautilus)
		target: self;
		label: 'Nautilus' translated;
		description: 'Settings related to the browser' translated;
		with: [
			(aBuilder setting: #openOnGroups)
				label: 'Open the browser on groups ?' translated;
				description: 'If true, Nautilus will show groups when opened' translated];
		with: [
			(aBuilder setting: #showHierarchy)
				label: 'Show hierarchy by default ?' translated;
				description: 'If false, Nautilus will show a flat list of classes' translated]! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/23/2011 13:06'!
open
	^ self openInEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/23/2011 13:05'!
openInEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:46'!
openOnCategory: aCategory ofClass: aClass

	^ self openOnCategory: aCategory ofClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:45'!
openOnCategory: aCategory ofClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: aCategory method: nil.
	instance open.
	
	instance ui methodsTree setSelectedNodeItem: aCategory.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:49'!
openOnClass: aClass

	^ self openOnClass: aClass inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 17:18'!
openOnClass: aClass inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: false.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	instance ui showPackages: false.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 14:56'!
openOnClass: aClass onGroup: aGroup
	
	^ self openOnClass: aClass onGroup: aGroup inEnvironment: self defaultBrowsedEnvironment.! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/25/2011 14:55'!
openOnClass: aClass onGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: aClass isMeta not.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance package: aClass package class: aClass category: nil method: nil.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:28'!
openOnGroup: aGroup

	^ self openOnGroup: aGroup inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:28'!
openOnGroup: aGroup inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: true.
	instance selectedGroup: aGroup.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:18'!
openOnGroups

	^ OpenOnGroups ifNil: [ OpenOnGroups := false ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:20'!
openOnGroups:aBoolean

	OpenOnGroups := aBoolean! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 13:19'!
openOnMethod: aMethod
	
	^ self openOnMethod: aMethod inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/26/2011 14:12'!
openOnMethod: aMethod inEnvironment: anEnvironment

	| instance class |
	class := aMethod methodClass.
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showInstance: class isMeta not.
	instance showGroups: false.
	instance package: class package class: class category: aMethod category asString method: aMethod.
	instance open.
	
	instance ui methodsTree forceSelection: aMethod category.
	instance ui methodsTree forceSelection: aMethod.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:43'!
openOnPackage: aPackage

	^ self openOnPackage: aPackage inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/27/2011 15:23'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories

	^ self openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: self defaultBrowsedEnvironment! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/27/2011 15:20'!
openOnPackage: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod group: selectedGroup showGroups: showGroups showHierarchy: showHierarchy showPackages: showPackages showComment: showComment  showInstance: showInstance showCategories: showCategories inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance
		showGroups: showGroups;
		showHierarchy: showHierarchy;
		showPackages: showPackages;
		showComment: showComment;
		showInstance: showInstance;
		showCategories: showCategories.
	
	instance package: selectedPackage class: selectedClass category: selectedCategory method: selectedMethod.
	instance selectedGroup: selectedGroup.
	
	instance open.
	instance ui methodsTree forceSelection: selectedCategory.
	instance ui methodsTree forceSelection: selectedMethod.
	
	^ instance! !

!Nautilus class methodsFor: 'opening' stamp: 'BenjaminVanRyseghem 3/22/2011 13:42'!
openOnPackage: aPackage inEnvironment: anEnvironment

	| instance |
	instance := self new.
	instance browsedEnvironment: anEnvironment.
	instance showGroups: false.
	instance selectedPackage: aPackage.
	instance open.
	^ instance! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:50'!
recentClassesElements

	^ self recentClasses mostViewedlements! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:44'!
resetCachedLastClasses

	^ cachedLastClasses := nil! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:05'!
showHierarchy

	^ ShowHierarchy ifNil: [ ShowHierarchy := true ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:06'!
showHierarchy: aBoolean

	ShowHierarchy := aBoolean! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 06:44'!
startUp
	" self startUp "

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:.! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 06:44'!
stopNotifications
	" self stopNotifications "
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allClasses

	^ self class environment allClassesAndTraits! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment

	^ browsedEnvironment ifNil: [ browsedEnvironment := BrowserEnvironment new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment: anEnvironment

	browsedEnvironment := anEnvironment! !

!Nautilus methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:55'!
classChanged: aClass

	ui ifNotNil:[ ui classChanged: aClass ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:19'!
classes
	
	^ self browsedEnvironment classes! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:07'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:11'!
foundExtentionsIn: aClass

	| result |
	result :=  aClass extendingPackages.
	"self haltIf: [result isEmpty not]."
	^ result! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:49'!
groupsManager
	
	^ self class groupsManager! !

!Nautilus methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:53'!
methodChanged: aCompiledMethod 

	ui ifNotNil:[ ui methodChanged: aCompiledMethod ]! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/20/2011 05:49'!
open

	ui := (self uiClass on: self) open! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 3/24/2011 11:05'!
package: aPackage class: aClass category: aCategory method: aMethod

	self 
		selectedPackage: aPackage;
		selectedClass: aClass;
		selectedCategory: aCategory;
		selectedMethod: aMethod.
		
	self registerHistoryNewEntry.! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:19'!
packages

	^ self browsedEnvironment packages asArray sort! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: 'StephaneDucasse 3/17/2011 15:25'!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'history' stamp: 'BenjaminVanRyseghem 3/24/2011 11:06'!
registerHistoryNewEntry
! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:50'!
resetGroupsManager

	GroupsManager := nil! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory: anObject

	selectedCategory := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/23/2011 15:59'!
selectedClass: anObject

	selectedClass := anObject.
	anObject ifNotNil: [ self recentClasses add: anObject ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:48'!
selectedGroup: anObject

	selectedGroup := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod: anObject

	selectedMethod := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:09'!
selectedPackage: anObject

	selectedPackage := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showCategories

	^ showCategories ifNil: [ showCategories := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:52'!
showCategories: aBoolean

	showCategories := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showComment

	^ showComment ifNil: [ showComment := false ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:52'!
showComment: aBoolean

	showComment := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:18'!
showGroups

	^ showGroups ifNil: [ showGroups := self class openOnGroups ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showGroups: aBoolean

	showGroups := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:07'!
showHierarchy

	^ showHierarchy ifNil: [ showHierarchy := self class showHierarchy ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showHierarchy: aBoolean

	showHierarchy := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showInstance

	^ showInstance ifNil: [ showInstance := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showInstance: aBoolean

	showInstance := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ showPackages ifNil: [ showPackages := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 17:17'!
showPackages: aBoolean
	showPackages := aBoolean.! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 17:15'!
ui

	^ ui! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:59'!
uiClass

	^ NautilusUI! !

Object subclass: #NautilusIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons Instance'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusIcons commentStamp: 'lr 7/10/2009 11:12' prior: 0!
Most of these icons come from http://www.famfamfam.com/lab/icons. They are licensed under the Creative Commons Attribution 3.0 License by Mark James.!

!NautilusIcons class methodsFor: 'accessing' stamp: 'lr 3/28/2009 16:15'!
default
   ^ Instance ifNil: [ Instance := self new ]! !

!NautilusIcons class methodsFor: 'accessing' stamp: 'dr 9/4/2008 16:35'!
iconNamed: aSymbol
	^ Icons at: aSymbol ifAbsentPut: [self default perform: aSymbol]! !

!NautilusIcons class methodsFor: 'initialization' stamp: 'lr 3/21/2009 19:49'!
initialize
	Instance := nil.
	Icons := IdentityDictionary new! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 7/10/2009 11:17'!
announcement
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168300858 976894522 976888885 34288443 993737531 993722369 959979575 673982238 103889690 87761712 705236742 120273668 87758851 152641799 789920516 959985427 204284436 488586007 34289723 993723152 926613505 168311098 976632635 473311541 1010580540 1007826230 840318012 1010580540 456396046 1010580540 1010580526 623262780 1010580540 1010580540 1010580540 1010580540)
	offset: 0@0)
	colorsFromArray: #(#(0.706 0.788 0.875) #(0.439 0.596 0.761) #(0.545 0.674 0.807) #(0.887 0.934 0.996) #(0.538 0.667 0.804) #(0.423 0.585 0.753) #(0.859 0.918 0.992) #(0.844 0.91 0.992) #(0.577 0.694 0.819) #(0.879 0.93 0.996) #(0.953 0.969 0.98) #(0.663 0.757 0.855) #(0.863 0.922 0.992) #(0.372 0.549 0.733) #(0.71 0.792 0.879) #(0.867 0.926 0.996) #(0.815 0.891 0.992) #(0.361 0.542 0.729) #(0.435 0.592 0.761) #(0.875 0.926 0.996) #(0.827 0.902 0.992) #(0.819 0.894 0.992) #(0.678 0.768 0.863) #(0.49 0.635 0.784) #(0.898 0.941 0.996) #(0.867 0.922 0.996) #(0.482 0.628 0.78) #(0.639 0.741 0.848) #(0.937 0.953 0.973) #(0.815 0.894 0.992) #(0.871 0.926 0.996) #(0.819 0.894 0.988) #(0.941 0.965 0.996) #(0.855 0.914 0.992) #(0.84 0.906 0.992) #(0.91 0.945 0.996) #(0.522 0.655 0.796) #(0.431 0.592 0.757) #(0.745 0.815 0.891) #(0.883 0.934 0.996) #(0.902 0.945 0.996) #(0.458 0.612 0.768) #(0.891 0.937 0.996) #(0.836 0.902 0.992) #(0.894 0.937 0.996) #(0.851 0.914 0.992) #(0.914 0.937 0.965) #(0.831 0.902 0.992) #(0.902 0.941 0.996) #(0.863 0.918 0.992) #(0.365 0.545 0.729) #(0.984 0.988 0.992) #(0.6 0.714 0.831) #(0.906 0.934 0.961) #(0.616 0.721 0.836) #(0.914 0.949 0.996) #(0.992 0.996 0.996) #(0.353 0.534 0.725) #(0.345 0.53 0.721) #(1.0 1.0 1.0)))! !

!NautilusIcons methodsFor: 'icons' stamp: 'BenjaminVanRyseghem 3/26/2011 00:51'!
arrowDown
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 185273099 185273099 185273098 168430090 168495883 185273098 151587081 168495883 185273098 151191561 168495883 185207306 151388169 168430091 185207049 151257353 151587339 185272841 328199 151653131 185273098 150997001 168495883 185273099 168364298 185273099 185273099 185207307 185273099 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.573 0.804 0.369) #(0.565 0.768 0.412) #(0.577 0.804 0.372) #(0.561 0.804 0.326) #(0.588 0.831 0.345) #(0.6 0.844 0.353) #(0.565 0.804 0.329) #(0.545 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.561 0.271) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 10:24'!
arrowUp
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185273099 185273099 185273099 185273099 185273099 185273099 185207307 185273099 185273099 168364298 185273099 185273098 150997001 168495883 185272841 328199 151653131 185207049 151257353 151587339 185207306 151388169 168430091 185273098 151191561 168495883 185273098 151587081 168495883 185273098 168430090 168495883 185273099 185273099 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.573 0.804 0.369) #(0.565 0.768 0.412) #(0.577 0.804 0.372) #(0.561 0.804 0.326) #(0.588 0.831 0.345) #(0.6 0.844 0.353) #(0.565 0.804 0.329) #(0.545 0.772 0.349) #(0.486 0.682 0.353) #(0.388 0.561 0.271) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 10:34'!
arrowUpAndDown
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 185273099 185207307 185273099 185273099 167772170 185273099 185273098 262400 168495883 185272832 67699971 658187 185204736 524800 2571 185207306 459776 168430091 185207306 394240 168430091 185204736 524800 2571 185272832 67699971 658187 185273098 262400 168495883 185273099 167772170 185273099 185273099 185207307 185273099)
	offset: 0@0)
	colorsFromArray: #(#(0.388 0.561 0.271) #(0.486 0.682 0.353) #(0.565 0.768 0.412) #(0.545 0.772 0.349) #(0.573 0.804 0.369) #(0.577 0.804 0.372) #(0.561 0.804 0.326) #(0.565 0.804 0.329) #(0.588 0.831 0.345) #(0.6 0.844 0.353) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/28/2009 16:04'!
blank
	^ Form extent: 12 @ 12 depth: 8! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 19:32'!
breakpoint
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 437654804 319885069 26 437590295 404100630 100859930 437524241 269290764 100860442 437327375 235736076 67305498 437261581 218893324 67305754 437130258 303174162 84082970 436931081 134678279 196890 437918234 437918234 196890 454761243 454761242 196890 454761243 454761242 196634 454761243 454761242 26)
	offset: 0@0)
	colorsFromArray: #(#(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.376 0.232 0.109) #(0.694 0.462 0.271) #(0.608 0.271 0.204) #(0.545 0.185 0.113) #(0.784 0.322 0.294) #(0.721 0.023 0.023) #(0.788 0.055 0.055) #(0.848 0.106 0.106) #(0.875 0.137 0.137) #(0.914 0.208 0.208) #(0.953 0.298 0.298) #(0.953 0.318 0.318) #(0.953 0.333 0.333) #(0.953 0.349 0.349) #(0.953 0.365 0.365) #(0.953 0.388 0.388) #(0.922 0.427 0.427) #(0.953 0.482 0.482) #(0.949 0.542 0.538) #(0.957 0.592 0.592) #(0.953 0.624 0.62) #(0.984 0.879 0.879) #(0.988 0.898 0.898) #(0.992 0.918 0.918) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:02'!
collection
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 168952850 171324982 909522486 255008812 271977989 285543990 706029348 70649368 724044854 254681884 271986469 689508662 135534100 137758237 890965046 909522486 909513472 436212534 909508866 151126326 909522486 909511457 807338806 909522486 909521969 841353526 909522486 909511458 504824630 909522486 909511943 755436854 909522486 909522486 909522486 909522486)
	offset: 0@0)
	colorsFromArray: #(#(0.565 0.764 0.538) #(0.992 0.98 0.934) #(0.957 0.879 0.549) #(0.953 0.867 0.514) #(1.0 0.569 0.286) #(0.577 0.772 0.553) #(0.557 0.761 0.53) #(0.957 0.875 0.538) #(1.0 0.949 0.914) #(0.937 0.827 0.369) #(1.0 0.953 0.922) #(0.953 0.871 0.53) #(0.542 0.753 0.518) #(0.992 0.98 0.926) #(0.937 0.965 0.934) #(1.0 0.678 0.466) #(1.0 0.667 0.451) #(0.408 0.678 0.372) #(1.0 0.694 0.494) #(0.93 0.961 0.926) #(1.0 0.682 0.478) #(0.918 0.631 0.447) #(1.0 0.557 0.271) #(0.848 0.757 0.384) #(0.545 0.745 0.506) #(0.561 0.686 0.522) #(0.392 0.671 0.357) #(0.466 0.659 0.423) #(0.887 0.53 0.298) #(0.514 0.71 0.474) #(0.807 0.737 0.458) #(0.887 0.796 0.423) #(0.91 0.628 0.443) #(0.93 0.84 0.466) #(0.894 0.804 0.435) #(0.831 0.553 0.372) #(0.823 0.542 0.357) #(0.643 0.772 0.604) #(0.804 0.733 0.443) #(0.871 0.588 0.408) #(0.498 0.698 0.462) #(0.612 0.733 0.573) #(1.0 0.577 0.306) #(0.639 0.764 0.6) #(0.926 0.569 0.337) #(0.937 0.823 0.353) #(0.937 0.581 0.349) #(0.419 0.686 0.388) #(0.883 0.811 0.53) #(0.894 0.823 0.534) #(0.848 0.776 0.494) #(0.973 0.612 0.38) #(0.941 0.831 0.384) #(0.573 0.694 0.534) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:10'!
exception
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1583238196 1191577949 759500554 1583225870 390089009 36066088 1578711384 857557019 906518110 1581393173 991970905 1549688414 722677332 570761514 1583242846 1327383559 1091971346 5322527 792346372 337270359 1297099812 1011548469 286015067 654532190 1583242842 941838926 1432247902 1583242763 221384798 1583242846 1583224899 1029594718 1583242846 1583231050 1583242846 1583242846)
	offset: 0@0)
	colorsFromArray: #(#(0.906 0.764 0.392) #(0.945 0.867 0.6) #(0.918 0.776 0.306) #(0.969 0.922 0.815) #(0.945 0.831 0.443) #(0.953 0.84 0.443) #(0.934 0.823 0.388) #(0.953 0.819 0.286) #(0.98 0.949 0.855) #(0.93 0.815 0.376) #(0.992 0.98 0.941) #(0.894 0.733 0.302) #(0.945 0.792 0.4) #(0.898 0.725 0.286) #(0.949 0.863 0.423) #(0.965 0.91 0.737) #(0.984 0.961 0.906) #(0.914 0.772 0.365) #(0.91 0.768 0.384) #(0.941 0.844 0.415) #(0.953 0.844 0.498) #(0.965 0.871 0.4) #(0.953 0.836 0.474) #(0.945 0.859 0.439) #(0.949 0.867 0.651) #(0.988 0.965 0.867) #(0.949 0.815 0.455) #(0.957 0.855 0.542) #(0.953 0.875 0.514) #(0.957 0.836 0.341) #(0.953 0.867 0.474) #(0.914 0.78 0.474) #(0.945 0.8 0.263) #(0.934 0.811 0.431) #(0.941 0.792 0.216) #(0.93 0.788 0.443) #(0.965 0.914 0.796) #(0.965 0.891 0.51) #(0.898 0.733 0.22) #(0.906 0.764 0.435) #(0.992 0.984 0.953) #(0.898 0.737 0.275) #(0.957 0.894 0.71) #(0.992 0.977 0.914) #(0.926 0.815 0.569) #(0.918 0.788 0.333) #(0.973 0.902 0.561) #(0.918 0.788 0.286) #(0.957 0.891 0.725) #(0.937 0.815 0.396) #(0.902 0.757 0.396) #(0.965 0.867 0.369) #(0.937 0.84 0.384) #(0.934 0.836 0.526) #(0.91 0.764 0.306) #(0.887 0.721 0.333) #(0.914 0.764 0.357) #(0.941 0.855 0.412) #(0.949 0.855 0.462) #(0.949 0.811 0.232) #(0.957 0.891 0.635) #(0.945 0.863 0.659) #(0.941 0.776 0.408) #(0.953 0.855 0.474) #(0.945 0.844 0.427) #(0.941 0.78 0.236) #(0.957 0.891 0.608) #(0.875 0.69 0.216) #(0.969 0.883 0.451) #(0.906 0.761 0.286) #(0.957 0.848 0.498) #(0.934 0.836 0.396) #(0.961 0.84 0.415) #(0.941 0.831 0.408) #(0.977 0.941 0.855) #(0.949 0.875 0.604) #(0.965 0.91 0.655) #(0.922 0.757 0.404) #(0.941 0.851 0.635) #(0.965 0.914 0.698) #(0.879 0.69 0.247) #(0.898 0.741 0.353) #(0.891 0.717 0.302) #(0.973 0.934 0.804) #(0.953 0.831 0.279) #(1.0 0.996 0.992) #(0.941 0.796 0.443) #(0.941 0.804 0.486) #(0.98 0.922 0.573) #(0.914 0.772 0.345) #(0.98 0.945 0.859) #(0.902 0.725 0.322) #(0.969 0.918 0.772) #(0.926 0.8 0.357) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 8/2/2007 19:32'!
flag
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 437918234 437918234 437918234 436470535 101584139 387389210 436404481 17105924 303634202 436666638 218827016 35198490 437126412 185075720 1644314 437060363 168298504 1644570 436930320 269422351 370743322 437326099 320082453 387520538 437918234 437918234 387520538 454761243 454761242 387520538 454761243 454761242 387520282 454761243 454761242 387389210)
	offset: 0@0)
	colorsFromArray: #(#(0.22 0.396 0.585) #(0.898 0.945 0.996) #(0.228 0.498 0.761) #(0.608 0.796 0.98) #(0.635 0.804 0.98) #(0.655 0.819 0.98) #(0.47 0.729 0.973) #(0.542 0.768 0.977) #(0.251 0.631 0.961) #(0.267 0.639 0.961) #(0.275 0.643 0.961) #(0.286 0.647 0.961) #(0.302 0.659 0.965) #(0.326 0.667 0.965) #(0.353 0.678 0.965) #(0.396 0.714 0.965) #(0.419 0.729 0.969) #(0.239 0.686 0.93) #(0.243 0.624 0.772) #(0.236 0.682 0.851) #(0.228 0.667 0.788) #(0.224 0.616 0.671) #(0.384 0.228 0.082) #(0.349 0.212 0.098) #(0.329 0.2 0.094) #(0.694 0.462 0.271) #(1.0 1.0 1.0) #( )))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:19'!
magnitude
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 874447653 738461995 85013556 875824136 573444634 471217204 875826957 607204404 875115572 875836464 489816628 875836468 875836468 50409268 875836468 875836468 268902708 875836468 875836418 101004340 875836468 875836448 167851060 873804852 875825163 204747815 874722356 875763995 321259818 335557684 875042605 102243847 930868 875836468 875836468 875836468)
	offset: 0@0)
	colorsFromArray: #(#(0.372 0.372 0.372) #(0.608 0.608 0.608) #(0.961 0.961 0.961) #(0.506 0.506 0.506) #(0.588 0.588 0.588) #(0.415 0.415 0.415) #(0.419 0.419 0.419) #(0.384 0.384 0.384) #(0.745 0.745 0.745) #(0.561 0.561 0.561) #(0.447 0.447 0.447) #(0.435 0.435 0.435) #(0.427 0.427 0.427) #(0.545 0.545 0.545) #(0.522 0.522 0.522) #(0.902 0.902 0.902) #(0.761 0.761 0.761) #(0.53 0.53 0.53) #(0.686 0.686 0.686) #(0.628 0.628 0.628) #(0.181 0.181 0.181) #(0.204 0.204 0.204) #(0.604 0.604 0.604) #(0.455 0.455 0.455) #(0.408 0.408 0.408) #(0.341 0.341 0.341) #(0.659 0.659 0.659) #(0.333 0.333 0.333) #(0.663 0.663 0.663) #(0.624 0.624 0.624) #(0.396 0.396 0.396) #(0.875 0.875 0.875) #(0.542 0.542 0.542) #(0.592 0.592 0.592) #(0.569 0.569 0.569) #(0.236 0.236 0.236) #(0.565 0.565 0.565) #(0.494 0.494 0.494) #(0.62 0.62 0.62) #(0.953 0.953 0.953) #(0.733 0.733 0.733) #(0.502 0.502 0.502) #(0.298 0.298 0.298) #(0.451 0.451 0.451) #(0.585 0.585 0.585) #(0.439 0.439 0.439) #(0.698 0.698 0.698) #(0.714 0.714 0.714) #(0.721 0.721 0.721) #(0.855 0.855 0.855) #(0.474 0.474 0.474) #(0.871 0.871 0.871) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:13'!
morph
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 1578631802 292362797 539127618 1895825665 2117994270 1445606482 202325275 1997372285 33573212 859313989 1763509875 1213866361 1064308758 192424752 1645101626 793665883 476466020 85208644 1751792704 621947215 1414349622 527711064 676669009 1346794755 1617375851 1095982919 656635516 1819423020 354700362 1695037706 154613091 420699479 75263577 2139062143 2139062143 2139062143)
	offset: 0@0)
	colorsFromArray: #(#(0.557 0.714 0.898) #(0.526 0.686 0.887) #(0.557 0.706 0.887) #(0.494 0.604 0.796) #(0.494 0.6 0.792) #(0.585 0.811 1.0) #(0.879 0.93 0.883) #(0.514 0.671 0.867) #(0.84 0.867 0.902) #(0.581 0.667 0.804) #(0.474 0.577 0.753) #(0.729 0.851 0.674) #(0.51 0.678 0.883) #(0.565 0.71 0.918) #(0.733 0.894 1.0) #(0.538 0.694 0.883) #(0.455 0.741 1.0) #(0.553 0.69 0.871) #(0.969 0.867 0.78) #(0.506 0.635 0.815) #(0.757 0.906 1.0) #(0.851 0.879 0.922) #(0.655 0.844 1.0) #(0.836 0.918 0.992) #(0.604 0.741 0.902) #(0.518 0.631 0.804) #(0.542 0.678 0.855) #(0.549 0.698 0.883) #(0.753 0.875 0.725) #(0.815 0.894 0.823) #(0.51 0.667 0.863) #(0.639 0.733 0.91) #(0.522 0.659 0.84) #(0.686 0.757 0.867) #(0.542 0.671 0.836) #(1.0 0.949 0.612) #(0.848 0.859 0.894) #(0.988 0.949 0.918) #(1.0 0.682 0.514) #(0.984 0.871 0.415) #(1.0 0.796 0.674) #(0.977 0.914 0.867) #(0.518 0.671 0.859) #(0.585 0.776 0.518) #(0.836 0.879 0.922) #(0.534 0.671 0.851) #(0.706 0.757 0.855) #(0.643 0.745 0.879) #(0.819 0.918 1.0) #(0.827 0.871 0.906) #(0.458 0.721 0.404) #(0.62 0.737 0.891) #(0.51 0.631 0.8) #(0.577 0.663 0.848) #(0.506 0.612 0.776) #(0.565 0.671 0.84) #(0.926 0.961 0.992) #(0.581 0.659 0.792) #(0.545 0.639 0.792) #(0.4 0.686 0.353) #(0.811 0.898 0.827) #(0.561 0.706 0.883) #(0.518 0.674 0.871) #(0.659 0.757 0.891) #(0.887 0.945 0.902) #(1.0 0.84 0.717) #(0.717 0.776 0.863) #(0.678 0.745 0.859) #(0.538 0.628 0.776) #(0.898 0.945 0.992) #(1.0 0.918 0.549) #(0.996 0.961 0.757) #(0.863 0.93 0.992) #(0.474 0.628 0.827) #(0.844 0.871 0.914) #(0.62 0.807 0.581) #(0.848 0.867 0.91) #(0.988 0.977 0.898) #(0.804 0.914 1.0) #(0.98 0.977 0.934) #(0.957 0.84 0.365) #(0.961 0.93 0.714) #(0.596 0.678 0.815) #(1.0 0.6 0.314) #(0.953 0.937 0.823) #(1.0 0.538 0.243) #(0.502 0.659 0.855) #(0.498 0.596 0.768) #(0.549 0.792 0.577) #(0.612 0.682 0.807) #(0.914 0.957 0.992) #(0.706 0.863 1.0) #(0.482 0.616 0.8) #(0.498 0.624 0.792) #(0.694 0.757 0.863) #(1.0 0.737 0.569) #(0.631 0.721 0.902) #(0.522 0.772 1.0) #(0.549 0.792 1.0) #(0.553 0.647 0.823) #(0.836 0.926 1.0) #(0.84 0.863 0.891) #(0.423 0.717 0.423) #(0.788 0.898 0.733) #(0.612 0.729 0.887) #(0.918 0.953 0.922) #(0.934 0.965 0.934) #(0.616 0.831 0.628) #(0.53 0.643 0.807) #(0.545 0.686 0.863) #(0.502 0.596 0.753) #(0.616 0.702 0.823) #(0.772 0.898 1.0) #(0.581 0.686 0.844) #(0.851 0.891 0.934) #(0.937 0.965 0.992) #(0.729 0.859 0.686) #(0.671 0.745 0.879) #(0.682 0.749 0.879) #(0.545 0.698 0.898) #(0.388 0.682 0.341) #(0.534 0.639 0.8) #(0.561 0.702 0.883) #(0.553 0.706 0.91) #(0.486 0.588 0.776) #(0.542 0.698 0.887) #(0.522 0.678 0.875) #( ) ))! !

!NautilusIcons methodsFor: 'icons' stamp: 'lr 3/29/2009 14:19'!
string
	^ ((ColorForm
	extent: 12@12
	depth: 8
	fromArray: #( 673716502 100672805 623061032 673717016 118757928 587409448 673710082 33825576 354166824 673717518 268698408 19277864 673714447 504037672 638134312 673720360 302655016 606152744 673720360 673588264 555886632 673720360 673456424 572991528 673720360 671621672 656418856 673720360 673654568 538912808 673720360 671948840 84682792 673720360 673128232 320284712)
	offset: 0@0)
	colorsFromArray: #(#(0.439 0.721 0.937) #(0.447 0.674 0.93) #(0.573 0.784 0.953) #(0.451 0.682 0.937) #(0.534 0.761 0.949) #(0.435 0.631 0.926) #(0.439 0.729 0.945) #(0.573 0.788 0.953) #(0.443 0.651 0.926) #(0.443 0.663 0.93) #(0.427 0.671 0.93) #(0.494 0.733 0.945) #(0.431 0.631 0.926) #(0.435 0.643 0.926) #(0.498 0.745 0.945) #(0.478 0.694 0.934) #(0.569 0.78 0.953) #(0.941 0.965 0.992) #(0.941 0.961 0.992) #(0.431 0.628 0.926) #(0.538 0.764 0.949) #(0.447 0.682 0.937) #(0.435 0.706 0.937) #(0.431 0.628 0.918) #(0.522 0.768 0.949) #(0.827 0.898 0.977) #(0.455 0.694 0.937) #(0.419 0.71 0.937) #(0.447 0.682 0.93) #(0.455 0.698 0.937) #(0.443 0.71 0.937) #(0.435 0.635 0.926) #(0.435 0.639 0.926) #(0.443 0.659 0.926) #(0.439 0.651 0.926) #(0.451 0.686 0.937) #(0.443 0.659 0.93) #(0.439 0.717 0.937) #(0.443 0.671 0.93) #(0.435 0.647 0.926) #( ) ))! !

Object subclass: #NautilusUI
	instanceVariableNames: 'model window methodsTree selectedMethod selectedCategory hierarchyClass cachedHierarchy sourceTextArea firstColumn secondColumn commentPane'
	classVariableNames: 'Icon'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI commentStamp: '<historical>' prior: 0!
I am browser in memory of Jules Vernes
I'm working on RPackage and with BrowserEnvironment!

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:51'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!NautilusUI class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 23:21'!
icon 

	^ Icon ifNil: [ Icon := self buildIcon ]! !

!NautilusUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
on: aNautilus

	^ self new model: aNautilus! !

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:48'!
resetIcon

	Icon := nil! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/20/2011 07:54'!
addAll: aWindow
			
			
	| row |
	aWindow
		addMorph: (self buildFirstColumn: aWindow)
		frame: (0@0 corner: 0.33@0.5).		
				
	aWindow
		addMorph: (self buildSecondColumn: aWindow)
		frame: (0.33@0 corner: 0.66@0.5).

	aWindow 
		addMorph: (self buildMethodsTree)
		frame: (0.66@0 corner: 1@0.5).
	
	
	"
	row := AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		layoutPolicy: ProportionalLayout new.
	window addMorph: row frame: (0@0.8 corner: 1@1).
	self buildClassCommentPane.
	window addMorph: commentPane fullFrame: commentPane defaultLayoutFrame."
	
aWindow
		addMorph: (self buildCodePane)
		frame: (0@0.5 corner: 1@1).! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/26/2011 12:58'!
addCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^ self].
	labels := OrderedCollection new.
	reject := Set new.
	reject
		addAll: self selectedClass organization categories;
		add: ClassOrganizer nullCategory;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	self selectedClass allSuperclasses do: [:cls | | cats |
		cls = Object ifFalse: [
			cats := cls organization categories reject:
				 [:cat | reject includes: cat].
			cats isEmpty ifFalse: [
				lines add: labels size.
				labels addAll: cats asSortedCollection.
				reject addAll: cats ]]].
	
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: 'Add Category'.
	newName ifNil: [ ^self ].
	newName := newName asSymbol.

	self selectedClass organization
		addCategory: newName
		before: self selectedCategory.
	self selectedCategory: newName.
	methodsTree update.
	methodsTree setSelectedNodeItem: newName.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
addClassInAGroup

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementToAdd: self selectedClass)
		open! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 14:44'!
addPackage

	| name |
	name := UIManager default request: 'Name of the new group:' initialAnswer: '' title: 'Create a new group'.
	(name isNil or: [name isEmpty])
		ifFalse: [ | package |
			package := self browsedEnvironment packageOrganizer createPackageNamed: name.
			self selectedPackage: package.
			self updatePackageView ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 13:53'!
addPackageAsGroup

	self selectedPackage
		ifNotNil: [:package | 
			^ (self groupsManager	
					addADynamicGroupSilentlyNamed: package name 
					model: package 
					selector: #orderedClasses)]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:44'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index

	(aClass subclasses sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes |
	
	classes := aClass subclasses intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
arrowKey: aCharacter from: aPluggableListMorph 
	aCharacter == $b
		ifTrue: [
			self selectedClass ifNotNil: [:class | class browse]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 23:28'!
asYetUnclassifiedString

	^ ClassOrganizer default! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:22'!
browseClassRefs

	| class |
	class := self selectedClass theNonMetaClass ifNil: [^self].
	class isTrait 
		ifTrue: [self systemNavigation browseAllUsersOfTrait: class]
		ifFalse: [self systemNavigation browseAllCallsOnClass: class]
! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:22'!
browseClassVarRefs

	| cls |
	cls := self selectedClass theNonMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseClassVarRefs: cls]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:02'!
browseInstVarDefs 

	| cls |
	cls := self selectedClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseInstVarDefs: cls]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:02'!
browseInstVarRefs

	| cls |
	cls := self selectedClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseInstVarRefs: cls]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 13:59'!
browseMessages
	
	self getSelectorAndSendQuery: #browseAllImplementorsOf: to: self systemNavigation with: {}! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 13:44'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self getSelectorAndSendQuery: #browseAllCallsOn: to: self systemNavigation with: {}! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:30'!
browseUnusedMethods
	
	self selectedClass
		ifNil: [^ self]
		ifNotNil: [:cls || classes unsent messageList |
			classes := Array with: cls with: cls class.
			unsent := Set new.
			classes
				do: [:c | unsent addAll: c selectors ].
			unsent := self systemNavigation allUnsentMessagesIn: unsent.
			messageList := OrderedCollection new.
			classes
				do: [:c | (c selectors
						select: [:s | unsent includes: s]) asSortedCollection
						do: [:sel | messageList add: c name , ' ' , sel]].
			self systemNavigation browseMessageList: messageList name: 'Unsent Methods in ' , cls name]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 23:37'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."
	| selector class result | 
	self showComment
		ifTrue: [ ClassCommentVersionsBrowser browseCommentOf: self selectedClass.
			^nil ].

	(selector := self selectedMethod selector)
		ifNil:[ self inform: 'Sorry, only actual methods have retrievable versions.'. ^nil ]
		ifNotNil: [
			class := self selectedClass.
			
			VersionsBrowser
				browseVersionsOf: self selectedMethod
				class: self selectedClass
				meta: class isMeta
				category: self selectedCategory
				selector: selector ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 12:27'!
browsedEnvironment

	^ self model browsedEnvironment! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/20/2011 07:34'!
buildClassCommentPane
	"Construct the pane that shows the class comment.
	Respect the setting StandardFonts codeFont."

	commentPane := BrowserCommentTextMorph
				on: self
				text: #selectedClassComments
				accept: #classComment:notifying:
				readSelection: nil
				menu: #codePaneMenu:shifted:.
	commentPane font: StandardFonts codeFont.
	^ commentPane! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/25/2011 13:29'!
buildCodePane

	sourceTextArea := PluggableTextMorph
				on: self
				text: #sourceCode
				accept: #compileSource:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	sourceTextArea beStyled.
	sourceTextArea askBeforeDiscardingEdits: true.
	^ sourceTextArea! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildCommentButton

	^ (PluggableButtonMorph
			on: self 
			getState: #commentButtonState
			action: #commentButtonAction
			label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/26/2011 13:28'!
buildFirstColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ firstColumn := GroupboxMorph new
			addContentMorph: self buildList;
			addContentMorph: (aWindow newRow: {self buildToogleButton. self buildGroupsButton});
			label: self labelText;
			hResizing: #spaceFill;
			vResizing: #spaceFill
			! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 16:08'!
buildGetterFor: aString

	^ aString,'

		^ ', aString! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:33'!
buildGroupHierarchyFor: aGroup

	| result coll1 |
	result := OrderedCollection new.
	self browsedEnvironment isSystem
		ifTrue: [ coll1 := aGroup elements ]
		ifFalse:[ coll1 := aGroup elements intersection: self model classes ].
	
	aGroup ifNil: [^ result ].
	((self rootsOfGroup: aGroup) asArray) do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: coll1 ].
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildHierarchyFor: aClass

	| result tmp index |
	
	aClass ifNil: [^ {}].
	result := OrderedCollection new.
	tmp := aClass withAllSuperclasses reverse.
	1 to: tmp size do: [:i | result add: (tmp at: i) -> (i-1)].

	index := (tmp size -1).
	self addSubclassesOf: aClass in: result withIndex: index + 1.
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/24/2011 16:09'!
buildList

	| list |
	list := PluggableListMorph
				on: self
				list: #getList
				selected: #selected
				changeSelected: #selected:
				menu: #menu:shifted:.
	list doubleClickSelector: #doubleClick.
	list wrapSelector: #listWrapper:.
	list hResizing: #spaceFill.
	list vResizing: #spaceFill.
	^ list! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/24/2011 16:09'!
buildList2

	| list2 |
	list2 := PluggableListMorph
				on: self
				list: #getList2
				selected: #selected2
				changeSelected: #selected2:
				menu: #menu2:shifted:.
	list2 doubleClickSelector: #doubleClick2.
	list2 wrapSelector: #listWrapper2:.
	list2 hResizing: #spaceFill.
	list2 vResizing: #spaceFill.
	^ list2! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/25/2011 17:48'!
buildMethodsTree

	methodsTree := SwitchableCategoriesTreeWithLabel
							on: self
							rootsSelector: #roots
							categoriesLabelSelector: #categoriesLabel
							elementsLabelSelector: #methodsLabel
							categoriesButtonLabelSelector: #categoriesButtonLabel
							elementsButtonLabelSelector: #methodsButtonLabel
							getSwitchSelector: #getSwitch
							setSwitchSelector: #setSwitch:
							getSelectedElementSelector: #selectedMethod
							setSelectedElementSelector: #selectedMethod:
							getSelectedCategorySelector: #selectedCategory
							setSelectedCategorySelector: #selectedCategory:
							setCategoryWrapperSelector: #categoryWrapper:
							setElementWrapperSelector: #methodWrapper:.
	methodsTree moveFromToIsCopySelector: #move:from:to:isCopy:.
	methodsTree elementIconSelector: #methodIconFor:.
	methodsTree categoryIconSelector: #classIconFor:.
	methodsTree
		categoriesMenuSelector: #categoriesMenu:shifted:;
		elementsMenuSelector: #elementsMenu:shifted:.
	^ methodsTree build! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:32'!
buildPackageHierarchyFor: aPackage

	| result coll1 coll2 |

	result := OrderedCollection new.
	self browsedEnvironment isSystem
		ifTrue: [
			coll1 := aPackage definedClasses.
			coll2 := aPackage extendedClasses ]
		ifFalse: [
			coll1 := self model classes intersection: aPackage definedClasses.
			coll2 := self model classes intersection: aPackage extendedClasses ].
	
	
	((self rootsOf: aPackage) asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: coll1].
	( coll2 asArray sort: [:a :b | a name <= b name ]) do:[:class |
		result add: (class -> 0)].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildPackagesClassesColumn: aWindow


	"container := PanelMorph new."
	"to fix in order to avoid the resize"
	
	"^ aWindow newColumn: {
			(aWindow newRow: {
				self buildFirstColumn: aWindow.
				self buildSecondColumn: aWindow})
				hResizing: #spaceFill; vResizing: #spaceFill.
			self buildToogleButton}"! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:38'!
buildRefactoringSubMenu

	| menu |
	menu := MenuMorph new defaultTarget: self.

	menu 
		add: 'Inst var refs...' translated 
		action: #browseInstVarRefs.
	menu 
		add: 'Inst var defs...' translated
		action: #browseInstVarDefs.
	menu 
		add: 'Create inst var accessors' translated
		action: #createInstVarAccessors.
	
	menu addLine.
	
	menu
		add: 'Class var refs...' translated
		action: #browseClassVarRefs.	
	menu 
		add: 'Class refs... (N)' translated
		action: #browseClassRefs.
		
	menu addLine.

	menu
		add: 'Unsent methods...' translated
		action: #browseUnusedMethods.
		
	menu
		add: 'Unreferenced inst vars...' translated
		action: #showUnreferencedInstVars.
	
	menu
		add: 'Unreferenced class vars...' translated
		action: #showUnreferencedClassVars.
	

	^ menu! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 06:49'!
buildRootsFromClass: aClass

	| result |
	result := Dictionary new.
	aClass ifNil: [^result].
	
	aClass methodDict values do: [:method || category |
		category := method category.
		(result at: category ifAbsent: [result at: category put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]).
		(result at: category) add: method].
	aClass organization categories do: [:each | 
		result 
			at: each 
			ifAbsent: [result at: each put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]
		].
	^ result ifEmpty: [result at: self noMethodsString put: OrderedCollection new;yourself]! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:57'!
buildSecondColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ secondColumn := GroupboxMorph new
			addContentMorph: self buildList2;
			addContentMorph: (aWindow newRow: {self buildInstanceButton. self buildCommentButton});
			label: self labelText2;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 16:10'!
buildSetterFor: aString

	^ aString, ': anObject
	
		', aString, ' := anObject'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildTabbedNameOf: anElement
			
	| tab result assoc |
	
	tab := '   '.
	result := ''.
	assoc := cachedHierarchy detect: [:each | each key == anElement ] ifNone: [''->0].
	1 to: assoc value do: [:i | result := tab, result].
	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			(package extendedClasses includes: anElement)
				ifTrue: [ result , '*', anElement name ]
				ifFalse: [ result, anElement name ]]! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildToogleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toogleButtonState
			action: #toogleButtonAction
			label: #toogleButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoriesButtonLabel

	^ 'Switch to methods'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 18:46'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Instance protocols:']
		ifFalse: ['Class protocols:']! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/26/2011 12:53'!
categoriesMenu: aMenu shifted: b

	self commonMenu: aMenu shifted: b.
	aMenu addLine.
		
	aMenu
		add: 'Rename...' translated
		target: self
		selector: #renameCategory.
	
	aMenu
		add: 'Remove empty categories' translated
		target: self
		selector: #removeEmptyCategories.
		
	aMenu
		add: 'Remove' translated
		target: self
		selector: #removeCategory.
		
	self categoriesRefactoringMenu: aMenu shifted: b.
		
	^ aMenu! !

!NautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
categoriesRefactoringMenu: aMenu shifted: b! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:14'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."

	| organizer organizers |
	organizer := self selectedClass organization.
	organizers := self selectedClass withAllSuperclasses collect: [:ea | ea organization].
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [:sel | | found |
		found := (organizers collect: [ :org | org categoryOfElement: sel])
			detect: [:ea | ea ~= ClassOrganizer default and: [ ea ~= nil]]
			ifNone: [].
		found ifNotNil: [organizer classify: sel under: found]].

	methodsTree update.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 19:12'!
categorizeMethod

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName item |
	self okToChange ifFalse: [^ self].
	self selectedMethod ifNil: [^ self].
	self selectedClass ifNil: [^self].
	labels := OrderedCollection new.
	labels
		addAll: self selectedClass organization categories;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	lines add: labels size -1.
	
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: ('Change Protocol (current: ', self selectedCategory,')').
	newName ifNil: [ ^self ].
	newName := newName asSymbol.
	item := self selectedMethod.
	
	item methodClass organization
				classify: item selector
				under: newName 
				suppressIfDefault: true.

	methodsTree update.
	methodsTree setSelectedNodeItem: item.! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoryWrapper: anItem

	^ anItem! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:58'!
changedLabels

	firstColumn label: self labelText.
	secondColumn label: self labelText2.! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/24/2011 15:42'!
classChanged: aClass
	
	self updateClassView! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/26/2011 00:49'!
classIconFor: aCategory

	^ nil! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
classLabel

	^'Class'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/27/2011 15:33'!
classesMenu: aMenu shifted: aBoolean 

	self selectedClass
		ifNotNil: [
			aMenu 
				add: 'Find Method... (f)' translated
				target: self
				selector: #findMethod.
			
			aMenu addLine.
			
			aMenu
				add: 'Browse full (b)' translated
				target: self
				selector: #fullBrowse.
				
			aMenu	
				add: 'Browse restricted (B)' translated
				target: self
				selector: #restrictedBrowseClass.	
				
			aMenu addLine.
			
			aMenu
				add: 'Analyzing' translated
				subMenu: self buildRefactoringSubMenu.
			
			aMenu
				add: 'Rename...' translated
				target: self 
				selector: #renameClass.
			
			aMenu
				add: 'Move to package...' translated
				target: self
				selector: #moveInNewPackage.
				
			aMenu
				add: 'Remove class (x)' translated
				target: self
				selector: #removeClass.
			
			aMenu addLine.
			
			aMenu
				add: 'File Out' translated
				target: self
				selector: #fileOutClass.
				
			aMenu addLine.
			
			self showGroups
				ifTrue: [
					aMenu
						add: 'Remove from Group (X)' translated
						target: self
						selector: #removeClassFromGroup]
				ifFalse: [
					aMenu
						add: 'Add in Group (e)' translated
						target: self
						selector: #addClassInAGroup]].! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 05:17'!
clearUserEditFlag
	
	sourceTextArea hasUnacceptedEdits: false.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 04:54'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	| donorMenu |
	donorMenu := shifted
				ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
				ifFalse: [SmalltalkEditor yellowButtonMenu].
	^ aMenu addAllFrom: donorMenu! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonAction

	self toogleShowComment! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonLabel

	^ self commentLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonState

	^ self showComment! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2011 09:57'!
commentLabel

	^ 'Comments'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/26/2011 13:52'!
commonMenu: aMenu shifted: b

	aMenu
		add: 'Browse full (b)' translated
		target: self
		selector: #fullBrowse.
		
	aMenu addLine.

	aMenu
		add: 'New Category...' translated
		target: self
		selector: #addCategory.
		
	aMenu
		add: 'Categorize all uncategorized' translated
		target: self
		selector: #categorizeAllUncategorizedMethods.

	^ aMenu! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/27/2011 20:06'!
compileSource: aText notifying: aController
	
	| source |
	source := aText asString.
	self selectedCategory
		ifNil: [
			(self selectedClass notNil and: [ self showComment ])
				ifTrue: [
					sourceTextArea update: #clearUserEdits.
					self selectedClass comment: source ]
				ifFalse:[
					(Compiler evaluate: source)
						ifNil: [^self]
						ifNotNil: [:class | 
							sourceTextArea update: #clearUserEdits.
							self selectedPackage: class package.
							self selectedClass: class.
							self showHierarchy
										ifTrue: [	self hierarchyClass: class ].
							self showGroups
								ifTrue: [ self updateClassView ]
								ifFalse: [ self updateBothView ]]]]
		ifNotNil: [:category |
			self selectedClass
				ifNil: ["should never happened" self error]
				ifNotNil: [:class || cat |
					cat := category.
					category = self noMethodsString
						ifTrue: [ cat := self asYetUnclassifiedString ].
					(class compile: source classified: cat notifying: aController)
						ifNil: [^ self ]
						ifNotNil: [:selector || method |
							sourceTextArea update: #clearUserEdits.
							method := class methodDict at: selector.
							methodsTree setSelectedNodeItem: method.
							( self selectedMethod notNil and: [(self selectedClass = class) and: [ self selectedMethod selector = selector]])
								ifFalse: [
									self selectedMethod: method.
									self update ]]]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:54'!
contentsSelection

	self selectedClass isNil
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [^ (1 to: self defaultMethodSource size) ]]].
	^ (1 to: 0)! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:11'!
createInstVarAccessors
	"Create getters and setters for all inst vars defined at the level of the current class selection, except do NOT clobber or override any selectors already understood by the instances of the selected class"

	self selectedClass
		ifNotNil:	[:aClass |
			aClass instVarNames do: [:aName || setter newMessage |
				(aClass canUnderstand: aName asSymbol)
					ifFalse: [
						newMessage := self buildGetterFor: aName.
						aClass compile: newMessage classified: 'accessing' notifying: nil].
				(aClass canUnderstand: (aName, ':') asSymbol)
					ifFalse:[
						newMessage :=self buildSetterFor: aName.
						aClass compile: newMessage classified: 'accessing' notifying: nil]]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:46'!
defaultMethodSource


	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:11'!
doItContext

	^ nil! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:12'!
doItReceiver

	^ self selectedClass theNonMetaClass! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 12:28'!
doubleClick

	self 
		ifGroups: [ self doubleClickOnGroup ]
		ifNot: [
			self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 14:02'!
doubleClick2

	self 
		ifPackages: [ self doubleClickOnClass ] 
		ifClasses: [ self doubleClickOnPackage ]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/25/2011 14:59'!
doubleClickOnClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil: [:class |
			self showGroups
				ifTrue: [ self model class openOnClass: class onGroup: self selectedGroup ]
				ifFalse: [ self model class openOnClass: class ]]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 13:45'!
doubleClickOnGroup

	self selectedGroup 
		ifNil: [ ^self ]
		ifNotNil:[:group | self model class openOnGroup: group ]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 13:45'!
doubleClickOnPackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package | self model class openOnPackage: package ]! !

!NautilusUI methodsFor: 'ugly compatibility' stamp: 'BenjaminVanRyseghem 3/20/2011 07:22'!
editSelection

	(self selectedClass notNil and: [self selectedCategory isNil])
		ifTrue: [^ #editClass].
	^ #other! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/27/2011 14:35'!
elementsMenu: aMenu shifted: b

	self commonMenu: aMenu shifted: b.
	aMenu addLine.
	
	aMenu
		add: 'Senders of...(n)' translated
		target: self
		selector: #browseSendersOfMessages.
	
	aMenu 
		add: 'Implementors of... (m)' translated
		target: self
		selector: #browseMessages.
		
	aMenu
		add: 'Inheritance (i)' translated
		target: self
		selector: #methodHierarchy.
		
	aMenu
		add: 'Versions (v)' translated
		target: self
		selector: #browseVersions.	
			
	aMenu addLine.
	
	aMenu
		add: 'Categorize method (C)' translated
		target: self
		selector: #categorizeMethod.
	
	aMenu
		add: 'Move to package...' translated
		target: self
		selector: #moveMethodToPackage.
			
	aMenu
		add: 'Remove method (x)' translated
		target: self
		selector: #removeMethod.
	
	self elementsRefactoringMenu: aMenu shifted: b.
	
	aMenu addLine.
	
	aMenu
		add: 'File Out' translated
		target: self
		selector: #fileOutMethod.
	
	^ aMenu! !

!NautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
elementsRefactoringMenu: aMenu shifted: b! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/26/2011 12:49'!
fileOutClass
	"Print a description of the selected class onto a file whose name is the 
	category name followed by .st."

	Cursor write 
		showWhile: [
			self selectedClass 
				ifNotNil: [:class | class fileOut ]]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/26/2011 14:21'!
fileOutMethod

	self selectedMethod
		ifNotNil: [:method |
			Cursor write 
				showWhile:
					[ method methodClass fileOutMethod: method selector ]]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/26/2011 14:17'!
fileOutPackage

	self selectedPackage
		ifNotNil: [:package | package fileOut ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/27/2011 15:08'!
findClass
	"Search for a class from a pattern or from the recent list"
	| pattern foundClassOrTrait recentList |
	self okToChange ifFalse: [^ self flashPackage ].
	recentList := self model recentClasses elements.
	recentList size == 0
		ifTrue: [pattern := UIManager default request: 'Class name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: recentList 
				lines: #() 
				title: 'Class name or fragment?'].
	pattern isBehavior
		ifTrue: [
			self showInstance: pattern isMeta not.
			self selectedPackage: pattern package.
			self selectedClass: pattern]
		ifFalse:[
			pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
			foundClassOrTrait := SystemNavigation default classFromPattern: pattern withCaption: ''.
			foundClassOrTrait ifNil: [^ self flashPackage].
			self selectedPackage: foundClassOrTrait package.
			self selectedClass: foundClassOrTrait].
	self updateBothView! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 15:17'!
findMethod
	"Search for a method in the lookup of the selected class"

	| recentList pattern foundMethod class |
	self okToChange ifFalse: [^ self flashPackage ].
	self selectedClass ifNil: [^ self flashPackage ].
	recentList := self selectedClass selectors.
	recentList size == 0
		ifTrue: [pattern := UIManager default request: 'Class name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: recentList 
				lines: #() 
				title: 'Class name or fragment?'].
			
	pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
	foundMethod := SystemNavigation default selectorFromPattern: pattern withCaption: '' startingFrom: self selectedClass.
	foundMethod ifNil: [^ self flashPackage].
	class := foundMethod methodClass.
	self showGroupsSilently: false.
 	self model package: class package class: class category: foundMethod category method: foundMethod.
	self updateBothView.
	methodsTree update.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:43'!
flashPackage

	"self 
		ifPackages: [ list flash ]
		ifClasses: [ list2 flash ]"! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
foundPackageOf: aClass

	aClass ifNil: [^ nil].
	^ aClass package! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/27/2011 15:21'!
fullBrowse

	self model class 
		openOnPackage: self selectedPackage
		class: self selectedClass
		category: self selectedCategory
		method: self selectedMethod
		group: self selectedGroup
		showGroups: self showGroups
		showHierarchy: self showHierarchy
		showPackages: self showPackages
		showComment: self showComment 
		showInstance: self showInstance 
		showCategories: self getSwitch
! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:33'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy collect: [:each | each key ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/26/2011 01:15'!
getClassHierarchy2

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy collect: [:each | each key ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:33'!
getClassesList

	^ self model classes! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy collect: [:assoc | assoc key] ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
getGroupsKeyList

	^ self groupsManager groups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 14:10'!
getGroupsValuesList

	^ self selectedGroup 
		ifNil: [{}]
		ifNotNil: [:group | group elements ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:25'!
getList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col collect: [:assoc | assoc key]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:25'!
getList2

	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/27/2011 20:27'!
getPackagesList

	^ self model packages reverse sort: [:a :b | a name first = $_ ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2011 14:43'!
getRawList
	
	^ self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					cachedHierarchy
						ifNil: [ self getClassHierarchy ]
						ifNotNil: [:col | col collect: [:assoc | assoc key]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 14:13'!
getRawList2

	self showPackages
		ifTrue: [
			cachedHierarchy
				ifNotNil:[:col | ^col collect: [:each | each key]]]
		ifFalse: [
			^ self 
				ifGroups: [ self getGroupsValuesList ]
				ifNot: [
					 self 
						ifPackages: [self getPackagesList2 ]
						ifClasses: [self getClassesList2 ]]]! !

!NautilusUI methodsFor: 'code holder behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 13:45'!
getSelectorAndSendQuery: querySelector to: queryPerformer with: queryArgs
	"Obtain a selector relevant to the current context, and then send the querySelector to the queryPerformer with the selector obtained and queryArgs as its arguments.  If no message is currently selected, then obtain a method name from a user type-in"

	| strm array |
	strm := (array := Array new: queryArgs size + 1) writeStream.
	strm nextPut: nil.
	strm nextPutAll: queryArgs.

	self selectedMethod ifNil: [ | selector |
		selector := UIManager default request: 'Type selector:' initialAnswer: 'flag:'.
		selector ifNil: [selector := String new].
		selector := selector copyWithout: Character space.
		^ selector isEmptyOrNil ifFalse: [
			(Symbol hasInterned: selector
				ifTrue: [ :aSymbol |
					array at: 1 put: aSymbol.
					queryPerformer perform: querySelector withArguments: array])
				ifFalse: [ self inform: 'no such selector']
		]
	].

	array at: 1 put: self selectedMethod selector.
	queryPerformer perform: querySelector withArguments: array! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
getSwitch 

	^ self model showCategories! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonAction

	self toogleShowGroups! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 17:04'!
groupsButtonLabel

	^ 
		self showGroups
			ifTrue: [ self packageLabel ]
			ifFalse: [ self groupsLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonState

	^ self showGroups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/23/2011 09:57'!
groupsLabel

	^ 'Groups'! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:52'!
groupsManager

	^ self model groupsManager! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/27/2011 15:33'!
groupsMenu: aMenu shifted: aBoolean 

	aMenu 
		add: 'Browse full (b)' translated
		target: self
		selector: #fullBrowse.	
		
	aMenu
		add: 'Browse restricted (B)' translated
		target: self
		selector: #restrictedBrowseGroup.

	aMenu addLine.

	self selectedGroup isNil
		ifFalse: [
			self selectedGroup isReadOnly
				ifFalse: [
					aMenu
						add: 'Rename (r)' translated
						target: self
						selector: #renameAGroup ].
			self selectedGroup removable
				ifTrue: [
					aMenu
						add: 'Remove (x)' translated
						target: self
						selector: #removeAGroup ]]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass

	^ hierarchyClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
initialize

	super initialize.
	cachedHierarchy := OrderedCollection new.! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceButtonAction

	self toogleShowInstance! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 18:43'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self classLabel ]
		ifFalse: [ self instanceLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 18:45'!
instanceButtonState

	^ false! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceLabel

	^'Instance'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 01:07'!
labelText

	^ self showGroups
		ifTrue: [ 'Groups:']
		ifFalse: [self ifPackages: ['Packages:'] ifClasses: ['Classes:']]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 13:59'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					self selectedPackage 
						ifNil: [ anElement name ]
						ifNotNil: [:package | 
							(package extendedClasses includes: anElement)
								ifTrue: [ '*', anElement name ]
								ifFalse: [ anElement name ]]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass package == anElement)
				ifTrue: [anElement name]
				ifFalse: ['*', anElement name]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/22/2011 14:17'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ self buildTabbedNameOf: anElement ]]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
menu2: aMenu shifted: aBoolean 
	self
		ifPackages: [self classesMenu: aMenu shifted: aBoolean]
		ifClasses: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]].
	^ aMenu! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
menu: aMenu shifted: aBoolean 
	self
		ifPackages: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]]
		ifClasses: [self classesMenu: aMenu shifted: aBoolean].
	^ aMenu! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/25/2011 23:33'!
methodChanged: aCompiledMethod 

	(aCompiledMethod methodClass = self selectedClass)
		ifTrue: [ methodsTree update ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 14:13'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self systemNavigation 
			methodHierarchyBrowserForClass: self selectedClass
			selector: self selectedMethod selector! !

!NautilusUI methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/26/2011 00:47'!
methodIconFor: aMethod

	aMethod containsHalt
		ifTrue: [ ^ NautilusIcons iconNamed: #breakpoint ].

	aMethod isOverride
		ifTrue: [ 
			aMethod isOverriden
				ifTrue: [ ^ NautilusIcons iconNamed: #arrowUpAndDown ]
				ifFalse:[	^ NautilusIcons iconNamed: #arrowUp ]].
	aMethod isOverriden
				ifTrue: [ ^ NautilusIcons iconNamed: #arrowDown ].
	^ NautilusIcons iconNamed: #blank! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodWrapper: anItem

	^ anItem selector! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodsButtonLabel

	^ 'Switch to categories'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 18:46'!
methodsLabel

	^ self showInstance
		ifTrue: ['Instance methods']
		ifFalse: ['Class methods']! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/26/2011 13:23'!
methodsTree
	
	^ methodsTree! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model

	^ model! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model: anObject

	model := anObject! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/25/2011 23:21'!
move: item from: oldCategory to: newCategory isCopy: isCopy

	isCopy
		ifFalse: [
			item methodClass organization
				classify: item selector
				under: newCategory 
				suppressIfDefault: true.
			self selectedMethod: item ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 15:17'!
moveInNewPackage

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName item |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^self].
	labels := self model packages collect: [:each | each name].
	lines := {0}.
		
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: ('Change Package (current: ', self selectedPackage name,')').
	newName ifNil: [ ^self ].
	newName := newName asSymbol.

	item := self browsedEnvironment packageOrganizer packageNamed: newName.
	self selectedPackage removeClass: self selectedClass.
	item addClassDefinition: self selectedClass.

	self selectedPackage: item.
	self updateBothView! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/27/2011 15:06'!
moveMethod: aMethod inPackage: aPackage

	aMethod methodClass organization
				classify: aMethod selector
				under: '*', aPackage name
				suppressIfDefault: true.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/27/2011 15:05'!
moveMethodToPackage

	"Search for a package from a pattern or from the recent list"
	| pattern foundPackage packagesList |
	self selectedMethod ifNil: [^ self ].
	self okToChange ifFalse: [^ self flashPackage ].
	packagesList := self model packages collect: [:each | each name ].
	packagesList size == 0
		ifTrue: [pattern := UIManager default request: 'Package name or fragment?']
		ifFalse: [pattern := UIManager default 
				enterOrRequestFrom: packagesList 
				lines: #() 
				title: 'Package name or fragment?'].
	pattern isEmptyOrNil ifTrue: [^ self flashPackage ].
	foundPackage := self systemNavigation packageFromPattern: pattern withCaption: ''.
	foundPackage ifNil: [^ self flashPackage].
	self selectedPackage = foundPackage ifTrue: [ ^ self ].
	
	self moveMethod: self selectedMethod inPackage: foundPackage.

	methodsTree update.
		
! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 23:28'!
noMethodsString

	^ ClassOrganizer nullCategory! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 05:31'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:43'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	window title: self title! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 17:05'!
packageLabel

	^'Packages'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/27/2011 15:32'!
packagesMenu: aMenu shifted: aBoolean 

	aMenu
		add: 'Find Class... (f)' translated
		target: self
		selector: #findClass.

	aMenu addLine.

	aMenu
		add: 'Browse full (b)' translated
		target: self
		selector: #fullBrowse.

	aMenu
		add: 'Browse restricted (B)' translated
		target: self
		selector: #restrictedBrowsePackage.

	aMenu addLine.
			
	aMenu
		add: 'Add Package...' translated
		target: self
		selector: #addPackage.
		
	aMenu
		add: 'Rename...' translated
		target: self
		selector: #renamePackage.

	aMenu
		add: 'Remove' translated
		target: self
		selector: #removePackage.

	aMenu addLine.

	aMenu
		add: 'File Out' translated
		target: self
		selector: #fileOutPackage.

	aMenu addLine.
	aMenu
		add: 'Add as Group & Browse (g)' translated
		target: self
		selector: #addPackageAsGroupAndBrowse.

	aMenu
		add: 'Add as Group (G)' translated
		target: self
		selector: #addPackageAsGroup! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 15:16'!
removeAGroup

	self groupsManager removeAGroup: self selectedGroup.
	self selectedGroup: nil.
	self updateBothView! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:01'!
removeCategory

	| messageCategoryName |
	self selectedCategory ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	messageCategoryName := self selectedCategory.
	(self confirm: 'Are you sure you want to
remove this method category 
and all its methods?')
		ifTrue: 
			[self selectedClass removeCategory: messageCategoryName.
			self selectedCategory: nil.
			methodsTree update]! !

!NautilusUI methodsFor: 'code holder behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 15:53'!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| message  className classToRemove result |
	self okToChange ifFalse: [^ false].
	classToRemove := self selectedClass ifNil: [Beeper beep. ^ false].
	classToRemove := classToRemove theNonMetaClass.
	className := classToRemove name.
	message := 'Are you certain that you
want to REMOVE the class ', className, '
from the system?'.
	(result := self confirm: message)
		ifTrue: 
			[classToRemove subclasses size > 0
				ifTrue: [(self confirm: 'class has subclasses: ' , message)
					ifFalse: [^ false]].
			classToRemove removeFromSystem.
			self selectedClass: nil.
			self updateClassView].
	^ result! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 15:16'!
removeClassFromGroup

	self groupsManager remove: self selectedClass from: self selectedGroup.
	self updateClassView.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:07'!
removeEmptyCategories

	self okToChange ifFalse: [^ self].
	(self roots at: self selectedCategory) 
		ifEmpty: [ self selectedCategory: nil ].
	self selectedClass organization removeEmptyCategories.
	methodsTree update.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:56'!
removeMethod
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "
	| messageName confirmation |
	self selectedMethod ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	messageName := self selectedMethod selector.
	confirmation := self systemNavigation   confirmRemovalOf: messageName on: self selectedClass.
	confirmation == 3
		ifTrue: [^ self].
	(self selectedClass includesLocalSelector: messageName)
		ifTrue: [self selectedClass removeSelector: messageName]
		ifFalse: [self removeNonLocalSelector: messageName].
	self selectedMethod: nil.
	methodsTree update.
	methodsTree setSelectedNodeItem: self selectedCategory.
	"In case organization not cached"
	confirmation == 2
		ifTrue: [self systemNavigation browseAllCallsOn: messageName]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:54'!
removeNonLocalSelector: aSymbol
	| traits isAlias |
	traits := self selectedClass traitsProvidingSelector: aSymbol.
	isAlias := self selectedClass isLocalAliasSelector: aSymbol.
	isAlias
		ifTrue: [
			[traits size = 1] assert.
			self selectedClass removeAlias: aSymbol of: traits first]
		ifFalse: [
			traits do: [:each |
				self selectedClass addExclusionOf: aSymbol to: each ]]
	! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/22/2011 18:17'!
removePackage

	self selectedPackage ifNil: [^ self].
	(UIManager default confirm: ('Are you sure you want to delete the package named ', self selectedPackage name, ' ?'))
		ifTrue: [
			self browsedEnvironment packageOrganizer unregisterPackage: self selectedPackage.
			self selectedPackage: nil.
			self updatePackageView]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/24/2011 15:24'!
renameAGroup

	| newName |
	self groupsManager renameAGroup: self selectedGroup.
	self updateBothView! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:28'!
renameCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"
	
	| oldIndex oldName newName |
	self selectedClass ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	self selectedCategory ifNil: [^ self].
	oldName := self selectedCategory.
	newName := UIManager default
		request: 'Please type new category name'
		initialAnswer: oldName.
	newName isEmptyOrNil
		ifTrue: [^ self]
		ifFalse: [newName := newName asSymbol].
	newName = oldName ifTrue: [^ self].
	self selectedClass organization
		renameCategory: oldName
		toBe: newName.
	self selectedCategory: newName.
	methodsTree update.
	methodsTree setSelectedNodeItem: newName.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:51'!
renameClass
	| oldName newName obs |
	self selectedClass ifNil: [ ^ self ].
	self okToChange ifFalse: [ ^ self ].
	
	oldName := self selectedClass name.
	newName := UIManager default  request: 'Please type new class name' initialAnswer: oldName.
	newName isEmptyOrNil ifTrue: [ ^ self ].	"Cancel returns"
	newName := newName asSymbol.
	newName = oldName ifTrue: [ ^ self ].
	(self class environment includesKey: newName)
		ifTrue: [ ^ self error: newName , ' already exists' ].
	self selectedClass rename: newName.
	self changed: #sourceCode.

	obs := self systemNavigation allReferencesTo: (self selectedClass environment associationAt: newName).
	obs isEmpty
		ifFalse: [ self systemNavigation browseMessageList: obs name: 'Obsolete References to ' , oldName autoSelect: oldName ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/22/2011 18:17'!
renamePackage

	| name |
	self selectedPackage ifNil: [^ self].
	name := UIManager default request: 'Name of the new group:' initialAnswer: '' title: 'Create a new group'.
	(name isNil or: [name isEmpty])
		ifFalse: [ | package |
			package := self browsedEnvironment packageOrganizer renamePackage: self selectedPackage in: name.
			self selectedPackage: package.
			self updatePackageView ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:58'!
restrictedBrowseClass

	self selectedClass
		ifNil: [ ^ self ]
		ifNotNil:[:class || newEnvironment |
			newEnvironment := self browsedEnvironment forClasses: {class}.
			 self model class openOnClass: class inEnvironment: newEnvironment ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/26/2011 14:30'!
restrictedBrowseGroup

	self selectedGroup
		ifNotNil: [:group || newEnvironment |
			newEnvironment := self browsedEnvironment forClasses: group elements.
			self model class openOnGroup: group inEnvironment: newEnvironment ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/22/2011 16:04'!
restrictedBrowsePackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package || newEnvironment |
			newEnvironment := self browsedEnvironment forPackages: {package}.
			 self model class openOnPackage: package inEnvironment: newEnvironment ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/19/2011 23:50'!
roots
		
	^ self buildRootsFromClass: self selectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:29'!
rootsOf: aPackage

	| list |
	self browsedEnvironment isSystem
		ifTrue: [ list := aPackage definedClasses ]
		ifFalse: [ list := self model classes intersection: aPackage definedClasses ].
		
	^ list select: [:each |
		(list includes: each superclass)  not]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 13:22'!
rootsOfGroup: aGroup

	| classes |
	self browsedEnvironment isSystem
		ifTrue: [ classes := aGroup elements ]
		ifFalse: [ classes := aGroup elements intersection: self model classes ].
	
	^ classes select: [:each |
		(classes includes: each superclass)  not]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 16:25'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 14:00'!
selected2

	| item |
	item :=  self 
		ifPackages: [ | tmp |
			tmp := self selectedClass.
			self showInstance ifFalse: [ tmp ifNotNil: [tmp := tmp soleInstance]].
			tmp ] 
		ifClasses: [ self selectedPackage ].
	.
	^self getRawList2 indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 16:07'!
selected2: anInteger

	| selection |
	selection := self getRawList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ 
			self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
			self selectedClass: selection ] 
		ifClasses: [	self selectedPackage: selection ].
	self changed: #selected2.
	! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 16:05'!
selected: anInteger

	| selection |
	
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroup: selection ]
		ifNot: [ self ifPackages: [ self selectedPackage: selection] ifClasses: [ self selectedClass: selection] ].

	self changed: #selected.! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/26/2011 00:37'!
selectedCategory

	^ self model selectedCategory! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/26/2011 13:22'!
selectedCategory: anObject

	self okToChange
		ifTrue: [
			self model package: self selectedPackage class: self selectedClass category: anObject method: nil.
			self changed: #sourceCode.
			self changed: #editSelection.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/19/2011 23:49'!
selectedCategorySilently: anObject

	selectedCategory := anObject.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 16:09'!
selectedClass

	| class |
	class := self model selectedClass.
	self setStylerClass: class.
	^ class! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/25/2011 17:23'!
selectedClass: aClass 

	| package |
	self okToChange
		ifTrue: [
			package := self selectedPackage.
			self showGroups
				ifTrue: [ aClass ifNotNil: [ package := aClass package ]].
			
			self model package: package class: aClass category: nil method: nil.
			
			self showPackages
				ifFalse: [ self updatePackageView ].
			self showGroups
				ifTrue: [ self updateClassView].
			self update.
			self changed: #sourceCode]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:19'!
selectedClassComments

	^ self selectedClass
		ifNil: ['']
		ifNotNil: [:class| class comment]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClassDescription

	^ self selectedClass definition! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedGroup
	
	^ self model selectedGroup! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 15:17'!
selectedGroup: anObject

	self okToChange
		ifTrue: [
			self model selectedGroup: anObject.
			self selectedClass: nil.
			self updateClassView ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/24/2011 12:56'!
selectedMethod
	
	^ self model selectedMethod ! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/24/2011 13:13'!
selectedMethod: aMethod 

	self okToChange
		ifTrue: [ | category |
			category := nil.
			aMethod ifNotNil: [ category := aMethod category ].
			self model package: self selectedPackage class: self selectedClass category: category method: aMethod.
			self changed: #sourceCode.
			^ true].
	^false ! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodComments

	^ self selectedMethod comment! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 05:32'!
selectedMethodSemiSilently: aCompiledMethod 

	self okToChange
		ifTrue: [
			self selectedMethodSilently: aCompiledMethod.
			aCompiledMethod ifNotNil: [ self selectedCategorySilently: aCompiledMethod category ]]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 05:20'!
selectedMethodSilently: aCompiledMethod 

	selectedMethod := aCompiledMethod.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodSource

	^ self selectedMethod getSource! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedPackage

	^ self model selectedPackage! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 12:48'!
selectedPackage: aPackage

	| class |
	self okToChange
		ifTrue: [
			class := self selectedClass.
			(self showPackages and: [class notNil and: [class package ~= aPackage]])
				ifTrue: [ class := nil ].
			self model package: aPackage class: class category: nil method: nil.

			self updateClassView.
			self update.
			self changed: #sourceCode]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 17:11'!
setCachedHierarchy: aDict

	cachedHierarchy := aDict.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/25/2011 17:11'!
setCachedHierarchyClass: aClass

	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/25/2011 14:30'!
setStylerClass: aClass

	sourceTextArea
		ifNotNil: [ sourceTextArea stylerClassOrMetaClass: aClass ]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
setSwitch: aBoolean

	^ self model showCategories: aBoolean! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showComment

	^ self model showComment! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showComment: aBoolean

	self model showComment: aBoolean.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showGroups

	^ self model showGroups! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/27/2011 15:29'!
showGroups: aBoolean

	self okToChange
		ifTrue: [
			self showPackages 
				ifFalse: [ self showPackagesSilently: true ].
			self selectedGroup
				ifNil: [ self selectedClass: nil ]
				ifNotNil: [:group | 
					(group elements includes: self selectedClass)
						ifFalse: [ self selectedClass: nil ]].
			self model showGroups: aBoolean.
			self changed: #groupsButtonLabel.
			self changedLabels.
			self updateBothView ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:36'!
showGroupsSilently: aBoolean

	self model showGroups: aBoolean! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showHierarchy

	^ self model showHierarchy! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
showHierarchy: aBoolean

	self model showHierarchy: aBoolean.
	aBoolean 
		ifTrue: [self hierarchyClass: self selectedClass]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showInstance

	^ self model showInstance! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
showInstance: aBoolean

	self model showInstance: aBoolean.
	self selectedClass 
		ifNotNil: [:class | 
			aBoolean 
				ifTrue: [self selectedClass: class soleInstance]
				ifFalse: [self selectedClass: class class]].
	methodsTree update.
	self changed: #instanceButtonLabel! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ self model showPackages! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 15:15'!
showPackages: aBoolean

	aBoolean ifFalse: [
		self hierarchyClass: self selectedClass].
	self showGroups
		ifTrue: [self showGroupsSilently: false].
	self model showPackages: aBoolean.
	self updateBothView.
	self changed: #toogleButtonState.
	self changedLabels.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 14:35'!
showPackagesSilently: aBoolean

	self model showPackages: aBoolean.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:34'!
showUnreferencedClassVars
	"Search for all class variables known to the selected class, and put up a 
	list of those that have no references anywhere in the system. The 
	search includes superclasses, so that you don't need to navigate your 
	way to the class that defines each class variable in order to determine 
	whether it is unreferenced"
	| cls aList aReport |
	((cls := self selectedClass) isNil or: [cls isTrait]) ifTrue: [^ self].
	aList := self systemNavigation allUnreferencedClassVariablesOf: cls.
	aList size == 0
		ifTrue: [^ UIManager default inform: 'There are no unreferenced
class variables in
' , cls name].
	aReport := String
				streamContents: [:aStream | 
					aStream nextPutAll: 'Unreferenced class variable(s) in ' translated, cls name;
						 cr.
					aList
						do: [:el | aStream tab; nextPutAll: el; cr]].
	UIManager default inform: aReport! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/25/2011 16:34'!
showUnreferencedInstVars
	"Search for all instance variables known to the selected class, and put up a list of those that have no references anywhere in the system.  The search includes superclasses, so that you don't need to navigate your way to the class that defines each inst variable in order to determine whether it is unreferenced"

	| cls aList aReport |
	((cls := self selectedClass) isNil or: [cls isTrait]) ifTrue: [^ self].
	aList := cls allUnreferencedInstanceVariables.
	aList size == 0 ifTrue: [^ UIManager default inform: 'There are no unreferenced
instance variables in
', cls name].
	aReport := String streamContents:
		[:aStream |
			aStream nextPutAll: 'Unreferenced instance variable(s) in ' translated, cls name; cr.
			aList do: [:el | aStream tab; nextPutAll: el; cr]].
	UIManager default inform: aReport! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/25/2011 14:41'!
sourceCode

	^self selectedClass isNil
		ifTrue: [
			self styled: true.
			self defaultClassDescriptor]
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [
							self styled: true.
							self defaultMethodSource]
						ifFalse: [
							self styled: false.
							self showComment
								ifTrue: [self selectedClassComments]
								ifFalse: [self selectedClassDescription]]]
				ifFalse: [
					self showComment
						ifTrue: [
							self styled: false.
							self selectedMethodComments]
						ifFalse: [
							self styled: true.
							self selectedMethodSource]]].
		! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/25/2011 13:32'!
styled: aBoolean

	sourceTextArea ifNotNil: [:sta | 
		aBoolean 
			ifTrue: [ sta beStyled ]
			ifFalse: [ sta beUnStyled ]]! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:41'!
taskbarIcon

	^ self class icon! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
title

	^'Nautilus'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 17:00'!
toogleButtonAction

	self selectedClass ifNil: [^self].
	self toogleShowPackages! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleButtonLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 16:47'!
toogleButtonState

	^ self showPackages not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowComment

	self showComment: self showComment not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/24/2011 15:16'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self updateBothView
! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowInstance

	self showInstance: self showInstance not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/26/2011 00:43'!
update

	self selectedCategory ifNil: [ methodsTree selection: MorphTreeMorphSingleSelection new ].
	methodsTree ifNotNil: [:tree | tree update]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:08'!
updateBothView

	self changed: #getList.
	self changed: #getList2! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:08'!
updateClassView

	self	
		ifPackages:  [ self changed: #getList2 ]
		ifClasses: [ self changed: #getList ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/24/2011 16:08'!
updatePackageView

	self	
		ifPackages: [ self changed: #getList ]
		ifClasses: [ self changed: #getList2 ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window

	^ window! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window: anObject

	window := anObject! !

!SystemNavigation methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 15:53'!
selectorFromPattern: pattern withCaption: aCaption startingFrom: aClass
	"I look after a selector matching the given pattern in the withSuperclasses of the given class"

	| toMatch potentialSelectorsList potentialSelectorsListNames methodsNames exactMatch index foundSelector separatorIndex className separatorName class |
	(toMatch := pattern
		copyWithoutAll:
			{(Character space).
			(Character cr).
			(Character tab)}) isEmpty
		ifTrue: [ ^ nil ].
	potentialSelectorsList := aClass withAllSuperclasses reverse gather: [:each | each methodDict ].
	Symbol
		hasInterned: toMatch
		ifTrue: [ :patternSymbol || result |
			"Exact symbol provided"
			result := OrderedCollection new.
			potentialSelectorsList do: [:each | 
				(each selector = patternSymbol)
				ifTrue: [result add: each]].
			result size = 1 ifTrue: [^ result first ]].
	toMatch := (toMatch copyWithout: $.) asLowercase.
	potentialSelectorsListNames := potentialSelectorsList collect: [:each | each methodClass name, '>>#', each selector ].
	methodsNames := pattern last = $.
		ifTrue: [ potentialSelectorsListNames select: [ :nm | nm asLowercase = toMatch ] ]
		ifFalse: [ potentialSelectorsListNames select: [ :n | n includesSubstring: toMatch caseSensitive: false ] ].
	methodsNames isEmpty
		ifTrue: [ ^ nil ].
	exactMatch := methodsNames detect: [ :each | each asLowercase = toMatch ] ifNone: [ nil ].
	index := methodsNames size = 1
		ifTrue: [ 1 ]
		ifFalse: [ 
			exactMatch
				ifNil: [ UIManager default chooseFrom: methodsNames lines: #() title: aCaption ]
				ifNotNil: [ 
					methodsNames addFirst: exactMatch.
					UIManager default chooseFrom: methodsNames lines: #(1) title: aCaption ] ].
	index = 0
		ifTrue: [ ^ nil ].
	foundSelector := methodsNames at: index.
	separatorIndex := foundSelector findString: '>>#'.
	className := foundSelector copyFrom: 1 to: separatorIndex-1.
	separatorName := foundSelector copyFrom: separatorIndex + 2 to: foundSelector size.
	class := Smalltalk at: (Symbol readFromString: '#',className).

	
	^ class methodDict at: (Symbol readFromString: separatorName)
"
	self default selectorFromPattern: 'op' withCaption: '' startingFrom: Boolean
	self default selectorFromPattern: 'zork' withCaption: '' startingFrom: Boolean
	self default selectorFromPattern: 'op' withCaption: '' startingFrom: NautilusWindow
	self default selectorFromPattern: 'openInWorld' withCaption: '' startingFrom: NautilusWindow
"! !
NautilusIcons initialize!
Nautilus initialize!
